package dev.shadowsoffire.apotheosis.adventure.socket;

import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.network.FriendlyByteBuf;
import com.google.gson.JsonObject;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.entity.player.Player;
import net.minecraft.core.RegistryAccess;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import net.minecraft.world.level.Level;
import net.minecraft.world.Container;
import net.minecraft.world.item.ItemStack;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;

public class WithdrawalRecipe extends AdventureModule.ApothSmithingRecipe implements ReactiveSmithingRecipe
{
    private static final ResourceLocation ID;
    
    public WithdrawalRecipe() {
        super(WithdrawalRecipe.ID, Ingredient.f_43901_, Ingredient.m_43929_(new ItemLike[] { (ItemLike)Adventure.Items.SIGIL_OF_WITHDRAWAL.get() }), ItemStack.f_41583_);
    }
    
    public boolean m_5818_(final Container pInv, final Level pLevel) {
        final ItemStack base = pInv.m_8020_(1);
        final ItemStack sigils = pInv.m_8020_(2);
        return base.m_41613_() == 1 && sigils.m_41720_() == Adventure.Items.SIGIL_OF_WITHDRAWAL.get() && SocketHelper.getGems(base).stream().anyMatch(GemInstance::isValid);
    }
    
    public ItemStack m_5874_(final Container pInv, final RegistryAccess regs) {
        final ItemStack out = pInv.m_8020_(1).m_41777_();
        if (out.m_41619_()) {
            return ItemStack.f_41583_;
        }
        SocketHelper.setGems(out, SocketedGems.EMPTY);
        return out;
    }
    
    public void onCraft(final Container inv, final Player player, final ItemStack output) {
        final ItemStack base = inv.m_8020_(1);
        final SocketedGems gems = SocketHelper.getGems(base);
        for (int i = 0; i < gems.size(); ++i) {
            final ItemStack stack = gems.get(i).gemStack();
            if (!stack.m_41619_()) {
                stack.m_41749_("uuids");
                if (!player.m_36356_(stack)) {
                    Block.m_49840_(player.m_9236_(), player.m_20183_(), stack);
                }
            }
        }
        SocketHelper.setGems(base, SocketedGems.EMPTY);
    }
    
    public RecipeSerializer<?> m_7707_() {
        return (RecipeSerializer<?>)Serializer.INSTANCE;
    }
    
    public RecipeType<?> m_6671_() {
        return (RecipeType<?>)RecipeType.f_44113_;
    }
    
    public boolean m_5598_() {
        return true;
    }
    
    static {
        ID = new ResourceLocation("apotheosis:widthdrawal");
    }
    
    public static class Serializer implements RecipeSerializer<WithdrawalRecipe>
    {
        public static Serializer INSTANCE;
        
        public WithdrawalRecipe fromJson(final ResourceLocation pRecipeId, final JsonObject pJson) {
            return new WithdrawalRecipe();
        }
        
        public WithdrawalRecipe fromNetwork(final ResourceLocation pRecipeId, final FriendlyByteBuf pBuffer) {
            return new WithdrawalRecipe();
        }
        
        public void toNetwork(final FriendlyByteBuf pBuffer, final WithdrawalRecipe pRecipe) {
        }
        
        static {
            Serializer.INSTANCE = new Serializer();
        }
    }
}
